/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


Main();


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // création du module AngularJS         
    var oModule = angular.module("AppliAngularJS", []);

    // déclaration des contrôleurs
    oModule.controller("MainControler", MainControler) 
      .controller("ViewControler", ViewControler)
      .service("ContactService", ContactService)
      .controller("ContactController", ContactController);

}


/**
 * Création d'un service avec plusieurs méthodes d'accès
 * 
 * @param {[type]} $scope [description]
 */
function ContactService()
{ 
    // création d'un idenfiant unique
    var uid = 2;// nombre d'éléments présents par défaut dans le tableau
    
    // tableau qui contient tous les contacts
    var aContacts = [{
        id: 0,
        'name': 'Dev Facile',
        'email': 'newsletter@actionscript-facile.com',
        'phone': '06-67-23-69-34'
    },
    {
        id: 1,
        'name': 'Matthieu Facile',
        'email': 'matthieu@actionscript-facile.com',
        'phone': '06-67-33-69-23'
    }];
    
    
    // les méthodes du service

    // sauvegarde du nouveau contact ou mise à jour d'un contact existant
    this.save = function (contact) 
    {
        if (contact.id == null) 
        {
            // c'est un nouveau contact, ajout dans le tableau
            contact.id = uid++;
            aContacts.push(contact);
        } 
        else 
        {
            // mise à jour d'un contact existant
            for (i in aContacts) 
            {
                if (aContacts[i].id == contact.id)
                    aContacts[i] = contact;
            }
        }

    }

    // recherche un contact à partir de son identifiant et renvoie un objet
    this.get = function (id) 
    {
        for (i in aContacts) 
        {
            // contact trouvé
            if (aContacts[i].id == id)
                return aContacts[i];
        }

    }
    
    // parcours de tous les contacts et suppression du contact - à partir de son identifiant
    this.delete = function (id) 
    {
        for (i in aContacts) 
        {
            // contact trouvé
            if (aContacts[i].id == id) 
                aContacts.splice(i, 1);
        }
    }

    // renvoie la liste de tous les contacts
    this.getAll = function () {return aContacts;}
} 



/**
 * Gestion des contacts
 * Ajout, suppression et mise à jour d'un contact
 * 
 * @param {[type]} $scope [description]
 */
function ContactController($scope, ContactService) 
{ 
    // récupère tous les contacts - affichage dans la vue
    $scope.contactsList = ContactService.getAll();

    // les méthodes du controler
    
    // sauvegarde d'un contact
    $scope.saveContact = function () 
    {
        ContactService.save($scope.newcontact);
        $scope.newcontact = {};
    }

    // suppression d'un contact
    $scope.deleteContact = function (id) 
    {
        ContactService.delete(id);
        if ($scope.newcontact.id == id) $scope.newcontact = {};
    }

    // édition d'un contact
    $scope.editContact = function (id) 
    {
        $scope.newcontact = angular.copy(ContactService.get(id));
    }
} 
   


/**
 * Déclaration des variables des vues
 * 
 * @param {[type]} $scope [description]
 */
function ViewControler($scope) 
{ 
    $scope.pageTitle = "Utilisation d'AngularJS"; 
} 
     

/**
 * Déclaration des variables nécessaires dans la zone gérée par AngularJS
 * 
 * @param {[type]} $scope [description]
 */
function MainControler($scope) 
{
    // représentation du modèle - les données
    $scope.user = { name: "Matthieu", site: "Développement Facile" }; 
    $scope.status = "banniere-cours-prog-facile-950";// affiche une image
    $scope.title = "Application Développement Facile"; 
} 
 

